diff -u -uNr arch.old/i386/boot/Makefile arch/i386/boot/Makefile
--- arch.old/i386/boot/Makefile	2002-12-04 00:57:54.000000000 +0100
+++ arch/i386/boot/Makefile	2003-05-17 17:59:42.000000000 +0200
@@ -36,6 +36,16 @@
 	cp -p $(TOPDIR)/System.map $(INSTALL_PATH)/
 	if [ -x /sbin/lilo ]; then /sbin/lilo; else /etc/lilo/install; fi
 
+zgrub: $(CONFIGURE) $(BOOTIMAGE)
+	if [ -f $(INSTALL_PATH)/vmlinuz-$(KERNELRELEASE) ]; then \
+		cp -p $(INSTALL_PATH)/vmlinuz-$(KERNELRELEASE) $(INSTALL_PATH)/vmlinuz-$(KERNELRELEASE).old; \
+	fi
+	if [ -f $(INSTALL_PATH)/System.map-$(KERNELRELEASE) ]; then \
+		cp -p $(INSTALL_PATH)/System.map-$(KERNELRELEASE) $(INSTALL_PATH)/System-$(KERNELRELEASE).old; \
+	fi
+	cp -p $(BOOTIMAGE) $(INSTALL_PATH)/vmlinuz-$(KERNELRELEASE)
+	cp -p $(TOPDIR)/System.map $(INSTALL_PATH)/System.map-$(KERNELRELEASE)
+
 install: $(CONFIGURE) $(BOOTIMAGE)
 	sh -x ./install.sh $(KERNELRELEASE) $(BOOTIMAGE) $(TOPDIR)/System.map "$(INSTALL_PATH)"
 
diff -u -uNr arch.old/i386/Makefile arch/i386/Makefile
--- arch.old/i386/Makefile	2002-11-29 00:53:09.000000000 +0100
+++ arch/i386/Makefile	2003-05-17 17:56:37.000000000 +0200
@@ -111,7 +111,7 @@
 FORCE: ;
 
 .PHONY: zImage bzImage compressed zlilo bzlilo zdisk bzdisk install \
-		clean archclean archmrproper archdep
+		clean archclean archmrproper archdep bzgrub
 
 zImage: vmlinux
 	@$(MAKEBOOT) zImage
@@ -129,6 +129,9 @@
 bzlilo: vmlinux
 	@$(MAKEBOOT) BOOTIMAGE=bzImage zlilo
 
+bzgrub: vmlinux
+	@$(MAKEBOOT) BOOTIMAGE=bzImage zgrub
+
 zdisk: vmlinux
 	@$(MAKEBOOT) BOOTIMAGE=zImage zdisk
 