diff -u yui/YAlignment.h yui-new/YAlignment.h
--- yui/YAlignment.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YAlignment.h	2007-10-10 14:45:58.000000000 +0100
@@ -58,7 +58,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YAlignment"; }
+    virtual const char *widgetClass() { return "YAlignment"; }
 
     /**
      * Moves a child widget to a new position.
diff -u yui/YBarGraph.h yui-new/YBarGraph.h
--- yui/YBarGraph.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YBarGraph.h	2007-10-10 14:46:12.000000000 +0100
@@ -40,7 +40,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YBarGraph"; }
+    virtual const char *widgetClass() { return "YBarGraph"; }
 
     /**
      * Returns the current number of bar segments, i.e. the nuber of values.
diff -u yui/YCheckBoxFrame.h yui-new/YCheckBoxFrame.h
--- yui/YCheckBoxFrame.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YCheckBoxFrame.h	2007-10-10 14:46:36.000000000 +0100
@@ -38,7 +38,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YCheckBoxFrame"; }
+    virtual const char *widgetClass() { return "YCheckBoxFrame"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YCheckBox.h yui-new/YCheckBox.h
--- yui/YCheckBox.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YCheckBox.h	2007-10-10 14:46:18.000000000 +0100
@@ -41,7 +41,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YCheckBox"; }
+    virtual const char *widgetClass() { return "YCheckBox"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YColoredLabel.h yui-new/YColoredLabel.h
--- yui/YColoredLabel.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YColoredLabel.h	2007-10-10 14:46:40.000000000 +0100
@@ -39,7 +39,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YColoredLabel"; }
+    virtual const char *widgetClass() { return "YColoredLabel"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YComboBox.h yui-new/YComboBox.h
--- yui/YComboBox.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YComboBox.h	2007-10-10 14:46:44.000000000 +0100
@@ -46,7 +46,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YComboBox"; }
+    virtual const char *widgetClass() { return "YComboBox"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YContainerWidget.h yui-new/YContainerWidget.h
--- yui/YContainerWidget.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YContainerWidget.h	2007-10-10 14:46:49.000000000 +0100
@@ -49,7 +49,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YContainerWidget"; }
+    virtual const char *widgetClass() { return "YContainerWidget"; }
 
     /**
      * Returns 'true' if there are any child widgets.
diff -u yui/YDate.h yui-new/YDate.h
--- yui/YDate.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YDate.h	2007-10-10 14:46:53.000000000 +0100
@@ -39,7 +39,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YDate"; }
+    virtual const char *widgetClass() { return "YDate"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YDialog.h yui-new/YDialog.h
--- yui/YDialog.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YDialog.h	2007-10-10 14:46:56.000000000 +0100
@@ -48,7 +48,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YDialog"; }
+    virtual const char *widgetClass() { return "YDialog"; }
 
     /**
      * Returns true, since this is a dialog widget.
diff -u yui/YDownloadProgress.h yui-new/YDownloadProgress.h
--- yui/YDownloadProgress.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YDownloadProgress.h	2007-10-10 14:46:59.000000000 +0100
@@ -42,7 +42,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YDownloadProgress"; }
+    virtual const char *widgetClass() { return "YDownloadProgress"; }
 
     /**
      * Implements the ChangeWidget() UI command.
diff -u yui/YDumbTab.h yui-new/YDumbTab.h
--- yui/YDumbTab.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YDumbTab.h	2007-10-10 14:47:02.000000000 +0100
@@ -38,7 +38,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YDumbTab"; }
+    virtual const char *widgetClass() { return "YDumbTab"; }
 
     /**
      * Implements the UI::ChangeWidget()
diff -u yui/YEmpty.h yui-new/YEmpty.h
--- yui/YEmpty.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YEmpty.h	2007-10-10 14:47:06.000000000 +0100
@@ -39,7 +39,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YEmpty"; }
+    virtual const char *widgetClass() { return "YEmpty"; }
 
     /**
      * Minimum size the widget should have to make it look and feel
diff -u yui/YFrame.h yui-new/YFrame.h
--- yui/YFrame.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YFrame.h	2007-10-10 14:47:14.000000000 +0100
@@ -38,7 +38,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YFrame"; }
+    virtual const char *widgetClass() { return "YFrame"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YImage.h yui-new/YImage.h
--- yui/YImage.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YImage.h	2007-10-10 14:47:17.000000000 +0100
@@ -38,7 +38,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YImage"; }
+    virtual const char *widgetClass() { return "YImage"; }
 };
 
 
diff -u yui/YIntField.h yui-new/YIntField.h
--- yui/YIntField.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YIntField.h	2007-10-10 14:47:19.000000000 +0100
@@ -43,7 +43,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YIntField"; }
+    virtual const char *widgetClass() { return "YIntField"; }
 
     /**
      * Implements the ChangeWidget() UI command.
diff -u yui/YLabel.h yui-new/YLabel.h
--- yui/YLabel.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YLabel.h	2007-10-10 14:47:22.000000000 +0100
@@ -40,7 +40,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YLabel"; }
+    virtual const char *widgetClass() { return "YLabel"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YLogView.h yui-new/YLogView.h
--- yui/YLogView.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YLogView.h	2007-10-10 14:47:24.000000000 +0100
@@ -43,7 +43,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YLogView"; }
+    virtual const char *widgetClass() { return "YLogView"; }
 
 
     /**
diff -u yui/YMenuButton.h yui-new/YMenuButton.h
--- yui/YMenuButton.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YMenuButton.h	2007-10-10 14:47:34.000000000 +0100
@@ -48,7 +48,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YMenuButton"; }
+    virtual const char *widgetClass() { return "YMenuButton"; }
 
     /**
      * Implements the ui command changeWidget for the widget specific
diff -u yui/YMultiLineEdit.h yui-new/YMultiLineEdit.h
--- yui/YMultiLineEdit.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YMultiLineEdit.h	2007-10-10 14:47:36.000000000 +0100
@@ -42,7 +42,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YMultiLineEdit"; }
+    virtual const char *widgetClass() { return "YMultiLineEdit"; }
 
 
     /**
diff -u yui/YMultiProgressMeter.h yui-new/YMultiProgressMeter.h
--- yui/YMultiProgressMeter.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YMultiProgressMeter.h	2007-10-10 14:47:41.000000000 +0100
@@ -44,7 +44,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YMultiProgressMeter"; }
+    virtual const char *widgetClass() { return "YMultiProgressMeter"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YMultiSelectionBox.h yui-new/YMultiSelectionBox.h
--- yui/YMultiSelectionBox.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YMultiSelectionBox.h	2007-10-10 14:47:43.000000000 +0100
@@ -44,7 +44,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YMultiSelectionBox"; }
+    virtual const char *widgetClass() { return "YMultiSelectionBox"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YPackageSelector.h yui-new/YPackageSelector.h
--- yui/YPackageSelector.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YPackageSelector.h	2007-10-10 14:47:48.000000000 +0100
@@ -41,7 +41,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YPackageSelector"; }
+    virtual const char *widgetClass() { return "YPackageSelector"; }
 
 
 };
diff -u yui/YPartitionSplitter.h yui-new/YPartitionSplitter.h
--- yui/YPartitionSplitter.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YPartitionSplitter.h	2007-10-10 14:47:53.000000000 +0100
@@ -52,7 +52,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YPartitionSplitter"; }
+    virtual const char *widgetClass() { return "YPartitionSplitter"; }
 
     /**
      * Implements the ChangeWidget() UI command.
diff -u yui/YProgressBar.h yui-new/YProgressBar.h
--- yui/YProgressBar.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YProgressBar.h	2007-10-10 14:47:56.000000000 +0100
@@ -43,7 +43,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YProgressBar"; }
+    virtual const char *widgetClass() { return "YProgressBar"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YPushButton.h yui-new/YPushButton.h
--- yui/YPushButton.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YPushButton.h	2007-10-10 14:47:59.000000000 +0100
@@ -41,7 +41,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YPushButton"; }
+    virtual const char *widgetClass() { return "YPushButton"; }
 
     /**
      * Implements the ui command changeWidget for the widget specific
diff -u yui/YRadioButtonGroup.h yui-new/YRadioButtonGroup.h
--- yui/YRadioButtonGroup.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YRadioButtonGroup.h	2007-10-10 14:48:05.000000000 +0100
@@ -44,7 +44,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YRadioButtonGroup"; }
+    virtual const char *widgetClass() { return "YRadioButtonGroup"; }
 
     /**
      * Returns true, since this is a radio button group
diff -u yui/YRadioButton.h yui-new/YRadioButton.h
--- yui/YRadioButton.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YRadioButton.h	2007-10-10 14:48:02.000000000 +0100
@@ -42,7 +42,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YRadioButton"; }
+    virtual const char *widgetClass() { return "YRadioButton"; }
 
     /**
      * Cleans up. Removes the button from the radio button group
diff -u yui/YReplacePoint.h yui-new/YReplacePoint.h
--- yui/YReplacePoint.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YReplacePoint.h	2007-10-10 14:48:08.000000000 +0100
@@ -37,7 +37,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YReplacePoint"; }
+    virtual const char *widgetClass() { return "YReplacePoint"; }
 
     /**
      * Inherited from YWidget. Returns true.
diff -u yui/YRichText.h yui-new/YRichText.h
--- yui/YRichText.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YRichText.h	2007-10-10 14:48:11.000000000 +0100
@@ -41,7 +41,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YRichText"; }
+    virtual const char *widgetClass() { return "YRichText"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YSelectionBox.h yui-new/YSelectionBox.h
--- yui/YSelectionBox.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YSelectionBox.h	2007-10-10 14:48:14.000000000 +0100
@@ -44,7 +44,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YSelectionBox"; }
+    virtual const char *widgetClass() { return "YSelectionBox"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YSelectionWidget.h yui-new/YSelectionWidget.h
--- yui/YSelectionWidget.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YSelectionWidget.h	2007-10-10 14:48:17.000000000 +0100
@@ -43,7 +43,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YSelectionWidget"; }
+    virtual const char *widgetClass() { return "YSelectionWidget"; }
 
     /**
      * The name of the widget property that holds the keyboard shortcut.
diff -u yui/YSlider.h yui-new/YSlider.h
--- yui/YSlider.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YSlider.h	2007-10-10 14:51:33.000000000 +0100
@@ -45,7 +45,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YSlider"; }
+    virtual const char *widgetClass() { return "YSlider"; }
 
     /**
      * Implements the ChangeWidget() UI command.
diff -u yui/YSpacing.h yui-new/YSpacing.h
--- yui/YSpacing.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YSpacing.h	2007-10-10 14:48:30.000000000 +0100
@@ -42,7 +42,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YSpacing"; }
+    virtual const char *widgetClass() { return "YSpacing"; }
 
     /**
      * Minimum size the widget should have to make it look and feel
diff -u yui/YSplit.h yui-new/YSplit.h
--- yui/YSplit.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YSplit.h	2007-10-10 14:48:32.000000000 +0100
@@ -41,7 +41,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YSplit"; }
+    virtual const char *widgetClass() { return "YSplit"; }
 
     /**
      * Returns the dimensions.
diff -u yui/YSquash.h yui-new/YSquash.h
--- yui/YSquash.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YSquash.h	2007-10-10 14:48:35.000000000 +0100
@@ -38,7 +38,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YSquash"; }
+    virtual const char *widgetClass() { return "YSquash"; }
 
     /**
      * In a squashed dimension the widget NOT stretchable.
diff -u yui/YTable.h yui-new/YTable.h
--- yui/YTable.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YTable.h	2007-10-10 14:48:38.000000000 +0100
@@ -63,7 +63,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YTable"; }
+    virtual const char *widgetClass() { return "YTable"; }
 
     /**
      * Adds an item to the table that is given as term
diff -u yui/YTextEntry.h yui-new/YTextEntry.h
--- yui/YTextEntry.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YTextEntry.h	2007-10-10 14:48:42.000000000 +0100
@@ -41,7 +41,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YTextEntry"; }
+    virtual const char *widgetClass() { return "YTextEntry"; }
 
 
     /**
diff -u yui/YTime.h yui-new/YTime.h
--- yui/YTime.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YTime.h	2007-10-10 14:48:45.000000000 +0100
@@ -39,7 +39,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YTime"; }
+    virtual const char *widgetClass() { return "YTime"; }
 
     /**
      * Implements the ui command changeWidget.
diff -u yui/YTree.h yui-new/YTree.h
--- yui/YTree.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YTree.h	2007-10-10 14:48:50.000000000 +0100
@@ -60,7 +60,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YTree"; }
+    virtual const char *widgetClass() { return "YTree"; }
 
 
     /**
diff -u yui/YWidget.h yui-new/YWidget.h
--- yui/YWidget.h	2007-08-10 16:33:29.000000000 +0100
+++ yui-new/YWidget.h	2007-10-10 14:45:46.000000000 +0100
@@ -62,7 +62,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char * widgetClass() { return "YWidget"; }
+    virtual const char * widgetClass() { return "YWidget"; }
 
     /**
      * Returns a descriptive label of this widget instance.
diff -u yui/YWizard.h yui-new/YWizard.h
--- yui/YWizard.h	2007-05-24 08:04:00.000000000 +0100
+++ yui-new/YWizard.h	2007-10-10 14:49:13.000000000 +0100
@@ -47,7 +47,7 @@
      * Returns a descriptive name of this widget class for logging,
      * debugging etc.
      */
-    virtual char *widgetClass() { return "YWizard"; }
+    virtual const char *widgetClass() { return "YWizard"; }
 
     /**
      * Generic direct access to implementation-specific functions.